#!/bin/bash
-
-# Desc: Records gps data until midnight
-# Author: Steven Baltakatei Sandoval; License: GPLv3+
-# Usage: bkgpslog -o [output dir]
+# Desc: Records gps data
#==BEGIN Define script parameters==
## Logging Behavior parameters
SCRIPT_TIME_START=$(date +%Y%m%dT%H%M%S.%N);
PATH="$HOME/.local/bin:$PATH"; # Add "$(systemd-path user-binaries)" path in case apps saved there
SCRIPT_HOSTNAME=$(hostname); # Save hostname of system running this script.
-SCRIPT_VERSION="0.3.10"; # Define version of script.
+SCRIPT_VERSION="0.5.7"; # Define version of script.
SCRIPT_NAME="bkgpslog"; # Define basename of script file.
SCRIPT_URL="https://gitlab.com/baltakatei/ninfacyzga-01"; # Define wesite hosting this script.
AGE_VERSION="1.0.0-beta2"; # Define version of age (encryption program)
declare -Ag fileRollCall # Associative array for storing file status
declare -Ag dirRollCall # Associative array for storing dir status
declare -a argRecPubKeys # for processArguments function
+# declare -a errorHistory # for correcting buffer lag
## Initialize variables
OPTION_VERBOSE=""; OPTION_ENCRYPT=""; OPTION_COMPRESS=""; OPTION_TMPDIR="";
+errReset=0; BUFFER_TTL_ADJ_FLOAT="";
#===BEGIN Declare local script functions===
checkapp() {
# Input: arg1: 'date'-parsable timestamp string (optional)
# Output: stdout: timestamp (ISO-8601, no separators)
# Depends: yell
- local TIME_CURRENT TIME_CURRENT_SHORT
+ local TIME_CURRENT TIME_CURRENT_SHORT argTime
argTime="$1";
# Get Current Time
TIME_INPUT="$argTime";
else
### F: Time argument not valid; exit
- yell "ERROR:Invalid time argument supplied. Exiting."; exit 1;
+ yell "ERROR:Invalid time argument supplied: \"$argTime\""; yell "Exiting."; exit 1;
fi
fi
# Construct and deliver separator-les date string
TIME_INPUT="$argTime";
else
### F: Time argument not valid; exit
- yell "ERROR:Invalid time argument supplied. Exiting."; exit 1;
+ yell "ERROR:Invalid time argument supplied: \"$argTime\""; yell "Exiting."; exit 1;
fi
fi
# Construct and deliver separator-les date string
# Return error if no condition matched.
return 1;
} # Validates strings
+timeEpochNS() {
+ # Desc: Get epoch nanoseconds
+ # Usage: timeEpochNS
+ # Version 0.2.2
+ # Input: arg1: 'date'-parsable timestamp string (optional)
+ # Output: Nanoseconds since 1970-01-01
+ # Depends: date 8, yell()
+ # Ref/Attrib: Force base 10 Bash arith with '10#'. https://stackoverflow.com/a/24777667
+ local TIME_CURRENT TIME_INPUT TIME_EPOCH_FLOAT TIME_EPOCH_NSFRAC
+ local TIME_EPOCH_NS
+
+ argTime="$1";
+
+ # Get Current Time
+ TIME_CURRENT="$(date --iso-8601=ns)"; # Produce `date`-parsable current timestamp with resolution of 1 nanosecond.
+
+ # Decide to parse current or supplied time
+ ## Check if time argument empty
+ if [[ -z "$argTime" ]]; then
+ ## T: Time argument empty, use current time
+ TIME_INPUT="$TIME_CURRENT";
+ else
+ ## F: Time argument exists, validate time
+ if date --date="$argTime" 1>/dev/null 2>&1; then
+ ### T: Time argument is valid; use it
+ TIME_INPUT="$argTime";
+ else
+ ### F: Time argument not valid; exit
+ yell "ERROR:Invalid time argument supplied. Exiting."; exit 1;
+ fi;
+ fi;
+ # Construct and deliver nanoseconds since 1970-01-01
+ TIME_EPOCH_FLOAT="$(date --date="$TIME_INPUT" +%s.%N)"; # Save ssss.NNNNNNNNN
+ TIME_EPOCH_INT="$(echo "$TIME_EPOCH_FLOAT" | cut -d. -f1)"; # Get ssss
+ TIME_EPOCH_NSFRAC="$(echo "$TIME_EPOCH_FLOAT" | cut -d. -f2)"; # Get NNNNNNNNN
+ TIME_EPOCH_NS="$(( (10#"$TIME_EPOCH_INT" * 10**9) + (10#"$TIME_EPOCH_NSFRAC") ))";
+ echo "$TIME_EPOCH_NS";
+} # Nanoseconds since 1970-01-01
+magicBufferSleepPID() {
+ # Desc: Compensates for lag so buffer rounds start every BUFFER_TTL seconds
+ # Input: vars: BUFFER_TTL, errResetx10e3, K_P, T_I, T_D
+ # # Input: array: errorHistory
+ # Output: vars: BUFFER_TTL_ADJ_FLOAT
+ # Re/Attrib: https://en.wikipedia.org/wiki/PID_controller#Standard_versus_parallel_(ideal)_form
+ local BUFFER_TTL_NS
+ local timeBufferStartNS timeBufferStartNSExp errNS errNSx10e3
+ local errResetx10e3 errRatex10e3 ADJ BUFFER_TTL_ADJ_NS BUFFER_TTL_ADJ_INT
+ local BUFFER_TTL_ADJ_FLOATFRAC
+ # local errorHistorySize
+
+ # ## Define errorHistorySize
+ # errorHistorySize=100;
+ ## Define BUFFER_TTL in nanoseconds
+ BUFFER_TTL_NS=$((BUFFER_TTL * 10**9)) && vbm "BUFFER_TTL_NS:$BUFFER_TTL_NS";
+
+ ### PID Control factors
+ K_P=1; # Gain for compensating buffer round lag
+ T_I="$(((4)*BUFFER_TTL_NS/(1)))"; # Consider this number of past nanoseconds to eliminate error
+ T_D="$(((1)*BUFFER_TTL_NS/(1)))"; # Predict value this number of nanoseconds into the future
+
+ # Calculate Error, errNS, in nanoseconds
+ ## Get current time
+ timeBufferStartNS="$(timeEpochNS)" && vbm "timeBufferStartNS :$timeBufferStartNS";
+ ## Calculate expected time (from start time, current buffer round number, nominal BUFFER_TTL)
+ timeBufferStartNSExp="$(( (timeBufferFirstNS) + (BUFFER_TTL_NS * bufferRound) ))" && vbm "timeBufferStartNSExp:$timeBufferStartNSExp";
+ ## Calculate error (diff between timeBufferStartNSExp and timeBufferStartNS; usually negative)
+ errNS="$(( timeBufferStartNSExp - timeBufferStartNS ))" && vbm "errNS:$errNS";
+# errNSx10e3="$((errNS*10**3))" && vbm "errNSx10e3:$errNSx10e3";
+ # ## Append error to errorHistory
+ # errorHistory+=("errNS");
+ # ### Trim errorHistory array if over errorHistorySize
+ # while [[ "${#errorHistory[@]}" -gt "errorHistorySize" ]]; then do
+ # unset "errorHistory[0]"; # remove oldest entry, creating sparse array
+ # errorHistory=("${errorHistory[@]}"); # reindex sparse array
+ # vbm "STATUS:Trimmed errorHistory array. Entry count:${#errorHistory[@]}";
+ # done;
+
+ # Calculate errReset in nanoseconds^2
+ ## errReset = int(errHistory(t),wrt(delta_BUFFER_TTL))
+ ## Integrate errorHistory with respect to time
+ # for value in "${errorHistory[@]}"; do
+ # errReset=$(( errReset + ( value*BUFFER_TTL_NS ) ));
+ # done;
+ vbm "errReset(orig):$errReset"
+ errReset="$(( (errReset + (errNS*BUFFER_TTL_NS)) ))" && vbm "errReset(post):$errReset";
+# errResetx10e3="$(( ( errResetx10e3 + ( errNSx10e3 * BUFFER_TTL_NS ) )*10**3 ))" && vbm "errResetx10e3:$errResetx10e3";
+
+ # Calculate errRate in nanoseconds per nanosecond
+ errRate="$(( errNS / BUFFER_TTL_NS ))" && vbm "errRate:$errRate";
+# errRatex10e3="$(( ( errNSx10e3 ) / BUFFER_TTL_NS ))" && vbm "errRatex10e3:$errRatex10e3";
+
+ # Debug
+ vbm "errNS :$errNS";
+ vbm "errResetTerm:$((errReset/T_I))";
+ vbm "errRateTerm :$((errRate*T_D))";
+
+ # Calculate PID control signal
+ ## ADJ = K_P * (errNS + errReset/T_I + errRate*T_D)
+ ADJ="$(( K_P*(errNS + errReset/T_I + errRate*T_D) ))" && vbm "ADJ:$ADJ";
+# ADJ="$((K_P*(errNSx10e3 + (errResetx10e3/T_I) + (errRatex10e3*T_D) )/(10**3)))" && vbm "ADJ:$ADJ";
+
+ # Calculate BUFFER_TTL_ADJ_FLOAT from ADJ (ns)
+ ## Calculate BUFFER_TTL_ADJ in nanoseconds (BUFFER_TTL_ADJ_NS = BUFFER_TTL_NS + ADJ)
+ BUFFER_TTL_ADJ_NS="$((BUFFER_TTL_NS + ADJ))" && vbm "BUFFER_TTL_ADJ_NS:$BUFFER_TTL_ADJ_NS";
+ ## Calculate integer seconds
+ BUFFER_TTL_ADJ_INT="$((BUFFER_TTL_ADJ_NS/(10**9)))" && vbm "BUFFER_TTL_ADJ_INT:$BUFFER_TTL_ADJ_INT";
+ ### Catch negative integer seconds, set minimum of BUFFER_TTL/10 seconds
+ if [[ "$BUFFER_TTL_ADJ_INT" -le "$((BUFFER_TTL/10))" ]]; then
+ BUFFER_TTL_ADJ_INT="$((BUFFER_TTL/10))";
+ yell "WARNING:Buffer lag adjustment yielded negative seconds.";
+ fi;
+ ## Calculate nanosecond remainder
+ ### Remove integer
+ BUFFER_TTL_ADJ_FLOATFRAC="$((BUFFER_TTL_ADJ_NS - (BUFFER_TTL_ADJ_INT*(10**9)) ))" && vbm "BUFFER_TTL_ADJ_FLOATFRAC:$BUFFER_TTL_ADJ_FLOATFRAC";
+ ### Calc absolute value of fraction (by removing '-' if present; see https://stackoverflow.com/a/47240327
+ BUFFER_TTL_ADJ_FLOATFRAC="${BUFFER_TTL_ADJ_FLOATFRAC#-}" && vbm "BUFFER_TTL_ADJ_FLOATFRAC:$BUFFER_TTL_ADJ_FLOATFRAC";
+ ## Form float BUFFER_TTL_ADJ_FLOAT
+ BUFFER_TTL_ADJ_FLOAT="$BUFFER_TTL_ADJ_INT"."$BUFFER_TTL_ADJ_FLOATFRAC" && vbm "BUFFER_TTL_ADJ_FLOAT:$BUFFER_TTL_ADJ_FLOAT";
+ vbm "STATUS:Calculated adjusted BUFFER_TTL (seconds):$BUFFER_TTL_ADJ_FLOAT";
+} # Calc BUFFER_TTL_ADJ_FLOAT so buffer starts every BUFFER_TTL seconds
magicWriteVersion() {
# Desc: Appends time-stamped VERSION to PATHOUT_TAR
# Usage: magicWriteVersion
} # bkgpslog: write version data to PATHOUT_TAR via appendArgTar()
magicGatherWriteBuffer() {
# Desc: bkgpslog-specific meta function for writing data to DIR_TMP then appending each file to PATHOUT_TAR
- # Inputs: PATHOUT_TAR FILEOUT_{NMEA,GPX,KML} CMD_CONV_{NMEA,GPX,KML} CMD_{COMPRESS,ENCRYPT} DIR_TMP,
- # Inputs: BUFFER_TTL bufferTTL_STR SCRIPT_HOSTNAME CMD_COMPRESS_SUFFIX CMD_ENCRYPT_SUFFIX
- # Depends: yell, try, vbm, appendArgTar, tar
- local FN="${FUNCNAME[0]}";
- wait; # Wait to avoid collision with older magicWriteBuffer() instances (see https://www.tldp.org/LDP/abs/html/x9644.html )
+ # Inputs: vars: PATHOUT_TAR FILEOUT_{NMEA,GPX,KML} CMD_CONV_{NMEA,GPX,KML} CMD_{COMPRESS,ENCRYPT} DIR_TMP,
+ # Inputs: vars: BUFFER_TTL bufferTTL_STR SCRIPT_HOSTNAME CMD_COMPRESS_SUFFIX CMD_ENCRYPT_SUFFIX
+ # Output: file: (PATHOUT_TAR)
+ # Depends: yell(), try(), vbm(), appendArgTar(), tar 1, sleep 8, checkMakeTar()
+ # Depends: magicWriteVersion(), appendFileTar()
+ local FN
+
+ vbm "DEBUG:STATUS:$FN:Started magicGatherWriteBuffer().";
+ # Debug:Get function name
+ FN="${FUNCNAME[0]}";
+
# Create buffer file with unique name
- PATHOUT_BUFFER="$DIR_TMP/buffer$SECONDS";
+ PATHOUT_BUFFER="$DIR_TMP/buffer$SECONDS" && vbm "PATHOUT_BUFFER:$PATHOUT_BUFFER";
# Fill buffer
timeout "$BUFFER_TTL"s gpspipe -r -o "$PATHOUT_BUFFER" ;
- timeBufferStart="$(dateTimeShort "$(date --date="$BUFFER_TTL seconds ago")")"; # Note start time
- vbm "DEBUG:STATUS:$FN:Started magicWriteBuffer().";
+ timeBufferStartLong="$(date --date="$BUFFER_TTL seconds ago" --iso-8601=seconds)" && vbm "timeBufferStartLong:$timeBufferStartLong" || yell "ERROR:timeBufferStartLong fail";
+ timeBufferStart="$(dateTimeShort "$timeBufferStartLong" )" && vbm "timeBufferStart:$timeBufferStart" || yell "ERROR:timeBufferStart fail"; # Note start time
# Determine file paths (time is start of buffer period)
FILEOUT_BASENAME="$timeBufferStart""--""$bufferTTL_STR""..""$SCRIPT_HOSTNAME""_location" && vbm "STATUS:Set FILEOUT_BASENAME to:$FILEOUT_BASENAME";
## Files saved to DIR_TMP
PATHOUT_KML="$DIR_TMP"/"$FILEOUT_KML" && vbm "STATUS:Set PATHOUT_KML to:$PATHOUT_KML";
## Files saved to disk (DIR_OUT)
### one file per day (Ex: "20200731..hostname_location.[.gpx.gz].tar")
- PATHOUT_TAR="$DIR_OUT"/"$(dateShort "$(date --date="$BUFFER_TTL seconds ago")")".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
+ PATHOUT_TAR="$DIR_OUT"/"$(dateShort "$(date --date="$BUFFER_TTL seconds ago" --iso-8601=seconds)")".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR";
# DEBUG: check vars
- vbm "STATUS:DIR_TMP :$DIR_TMP";
- vbm "STATUS:PATHOUT_TAR :$PATHOUT_TAR";
- vbm "STATUS:PATHOUT_NMEA:$PATHOUT_NMEA";
- vbm "STATUS:PATHOUT_GPX:$PATHOUT_GPX";
- vbm "STATUS:PATHOUT_KML:$PATHOUT_KML";
+ vbm "STATUS:FN :$FN";
+ vbm "STATUS:DIR_TMP :$DIR_TMP";
+ vbm "STATUS:PATHOUT_TAR :$PATHOUT_TAR";
+ vbm "STATUS:PATHOUT_NMEA :$PATHOUT_NMEA";
+ vbm "STATUS:PATHOUT_GPX :$PATHOUT_GPX";
+ vbm "STATUS:PATHOUT_KML :$PATHOUT_KML";
+ vbm "STATUS:BUFFER_TTL :$BUFFER_TTL";
+ vbm "STATUS:PATHOUT_BUFFER :$PATHOUT_BUFFER";
+ vbm "STATUS:timeBufferStart:$timeBufferStart";
+ vbm "FILEOUT_BASENAME :$FILEOUT_BASENAME";
# Validate PATHOUT_TAR as tar.
checkMakeTar "$PATHOUT_TAR";
## Add VERSION file if checkMakeTar had to create a tar (exited 1) or replace one (exited 2)
+ vbm "exit status before magicWriteVersion:$?"
if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi
# Write bufferBash to PATHOUT_TAR
+ wait; # Wait to avoid collision with older magicWriteBuffer() instances (see https://www.tldp.org/LDP/abs/html/x9644.html )
appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_NMEA" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_NMEA" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write NMEA data
appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_GPX" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_GPX" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write GPX file
appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_KML" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_KML" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write KML file
# Remove secured chunks from DIR_TMP
rm "$PATHOUT_BUFFER" "$PATHOUT_NMEA" "$PATHOUT_GPX" "$PATHOUT_KML";
- vbm "DEBUG:STATUS:$FN:Finished magicWriteBuffer().";
+ vbm "DEBUG:STATUS:$FN:Finished magicGatherWriteBuffer().";
} # write buffer to disk
magicParseRecipientDir() {
# Desc: Updates recPubKeysValid with pubkeys in dir specified by '-R' option ("recipient directory")
- # Inputs: vars: OPTION_RECDIR, argRecDir, OPTION_ENCRYPTION
+ # Inputs: vars: OPTION_RECDIR, argRecDir, OPTION_ENCRYPT
# arry: recPubKeysValid
# Outputs: arry: recPubKeysValid
# Depends: processArguments,
declare -a candRecPubKeysValid
# Check that '-e' and '-R' set
- if [[ "$OPTION_ENCRYPTION" = "true" ]] && [[ "$OPTION_RECDIR" = "true" ]]; then
+ if [[ "$OPTION_ENCRYPT" = "true" ]] && [[ "$OPTION_RECDIR" = "true" ]]; then
### Check that argRecDir is a directory.
if [[ -d "$argRecDir" ]]; then
- recipientDir="$argRecDir";
+ recipientDir="$argRecDir" && vbm "STATUS:Recipient watch directory detected:\"$recipientDir\"";
#### Initialize variable indicating outcome of pubkey review
unset updateRecipients
#### Add existing recipients
- candRecPubKeysValid=("${recPubKeysValid[@]}");
+ candRecPubKeysValid=("${recPubKeysValidStatic[@]}");
#### Parse files in recipientDir
for file in "$recipientDir"/*; do
##### Read first line of each file
- recFileLine="$(head -n1 "$file")";
+ recFileLine="$(head -n1 "$file")" && vbm "STATUS:Checking if pubkey:\"$recFileLine\"";
##### check if first line is a valid pubkey
if checkAgePubkey "$recFileLine" && \
( validateInput "$recFileLine" "ssh_pubkey" || validateInput "$recFileLine" "age_pubkey"); then
###### T: add candidate pubkey to candRecPubKeysValid
- candRecPubKeysValid+=("$recFileLine");
+ candRecPubKeysValid+=("$recFileLine") && vbm "STATUS:RecDir pubkey is valid pubkey:\"$recFileLine\"";
else
###### F: throw warning;
yell "ERROR:Invalid recipient file detected. Not modifying recipient list."
done
#### Write updated recPubKeysValid array to recPubKeysValid if no failure detected
if ! [[ "$updateRecipients" = "false" ]]; then
- recPubKeysValid=("${candRecPubKeysValid[@]}");
+ recPubKeysValid=("${candRecPubKeysValid[@]}") && vbm "STATUS:Wrote candRecPubkeysValid to recPubKeysValid:\"${recPubKeysValid[*]}\"";
fi;
else
yell "ERROR:$0:Recipient directory $argRecDir does not exist. Exiting."; exit 1;
fi;
fi;
- # Handle case if '-e' set but '-R' not set
- if [[ "$OPTION_ENCRYPTION" = "true" ]] && [[ ! "$OPTION_RECDIR" = "true" ]]; then
- yell "ERROR: \\'-e\\' set but \\'-R\\' is not set."; fi;
# Handle case if '-R' set but '-e' not set
- if [[ ! "$OPTION_ENCRYPTION" = "true" ]] && [[ "$OPTION_RECDIR" = "true" ]]; then
+ if [[ ! "$OPTION_ENCRYPT" = "true" ]] && [[ "$OPTION_RECDIR" = "true" ]]; then
yell "ERROR: \\'-R\\' is set but \\'-e\\' is not set."; fi;
} # Update recPubKeysValid with argRecDir
magicParseRecipientArgs() {
# Input: vars: OPTION_ENCRYPT from processArguments()
# arry: argRecPubKeys from processArguments()
# Output: vars: CMD_ENCRYPT, CMD_ENCRYPT_SUFFIX
- # arry: recPubKeysValid
+ # arry: recPubKeysValid, recPubKeysValidStatic
# Depends: checkapp(), checkAgePubkey(), validateInput(), processArguments()
local recipients
fi;
done
vbm "DEBUG:Finished processing argRecPubKeys array";
+ vbm "STATUS:Array of validated pubkeys:${recPubKeysValid[*]}";
+ recPubKeysValidStatic=("${recPubKeysValid[@]}"); # Save static image of pubkeys validated by this function
## Form age command string
CMD_ENCRYPT="age ""$recipients " && vbm "CMD_ENCRYPT:$CMD_ENCRYPT";
## T: Check if argCustomBufferTTL is an integer
if validateInput "$argCustomBufferTTL" "integer"; then
### T: argCustomBufferTTL is an integer
- BUFFER_TTL="$argCustomBufferTTL";
+ BUFFER_TTL="$argCustomBufferTTL" && vbm "Custom BUFFER_TTL from -b:$BUFFER_TTL";
else
### F: argcustomBufferTTL is not an integer
yell "ERROR:Invalid integer argument for custom buffer time-to-live."; showUsage; exit 1;
## T: Check if argCustomScriptTTL is a time element (ex: "day", "hour")
if validateInput "$argCustomScriptTTL" "time_element"; then
### T: argCustomScriptTTL is a time element
- SCRIPT_TTL_TE="$argCustomScriptTTL";
+ SCRIPT_TTL_TE="$argCustomScriptTTL" && vbm "Custom SCRIPT_TTL_TE from -B:$SCRIPT_TTL_TE";
else
### F: argcustomScriptTTL is not a time element
yell "ERROR:Invalid time element argument for custom script time-to-live."; showUsage; exit 1;
main() {
+ # DEBUG: Print environment variables
+ vbm "echo $(printenv)";
# Process arguments
processArguments "$@";
## Act upon arguments
magicInitWorkingDir; # Sets DIR_TMP from argTempDirPriority
### Set output encryption and compression option strings
#### React to "-r" ("encryption recipients") option
- magicParseRecipientArgs; # Updates recPubKeysValid, CMD_ENCRYPT[_SUFFIX]
+ magicParseRecipientArgs; # Updates recPubKeysValid, CMD_ENCRYPT[_SUFFIX] from argRecPubKeys
#### React to "-c" ("compression") option
magicParseCompressionArg; # Updates CMD_COMPRESS[_SUFFIX]
#### React to "-R" ("recipient directory") option
bufferTTL_STR="$(timeDuration "$BUFFER_TTL")";
# Init temp working dir
- try mkdir "$DIR_TMP" && vbm "DEBUG:Working dir creatd at:$DIR_TMP";
+ try mkdir "$DIR_TMP" && chmod +t "$DIR_TMP" && vbm "DEBUG:Working dir creatd at:$DIR_TMP";
# Initialize 'tar' archive
## Define output tar path (note: each day gets *one* tar file (Ex: "20200731..hostname_location.[.gpx.gz].tar"))
CMD_CONV_KML="gpsbabel -i nmea -f - -o kml -F - " && vbm "STATUS:Set CMD_CONV_KML to:$CMD_CONV_KML"; # convert NMEA to KML
# MAIN LOOP:Record gps data until script lifespan ends
+ timeBufferFirstNS="$(timeEpochNS)"; bufferRound=0; BUFFER_TTL_ADJ_FLOAT="$BUFFER_TTL";
while [[ "$SECONDS" -lt "$SCRIPT_TTL" ]]; do
+ magicParseRecipientDir;
magicGatherWriteBuffer &
- sleep "$BUFFER_TTL";
+ sleep "$BUFFER_TTL_ADJ_FLOAT"; # adjusted by magicBufferSleepPID
+ ((bufferRound++));
+ magicBufferSleepPID; # Calculates BUFFER_TTL_ADJ_FLOAT from BUFFER_TTL given buffer expected start time vs. actual
done
# Cleanup
## Remove DIR_TMP
- try rm -r "$DIR_TMP";
+ try rm -r "$DIR_TMP" && vbm "Removed DIR_TMP:$DIR_TMP";
vbm "STATUS:Main function finished.";
} # Main function.
main "$@" # Run main function.
exit 0;
#==END Perform work and exit==
+
+# Author: Steven Baltakatei Sandoval;
+# License: GPLv3+